// Copyright (C) 2022-2024 B.R.S. Roso.
// 
// Rfeed is free software: you can redistribute it and/or modify it under the
// terms of the GNU General Public License version 3 as published by the Free
// Software Foundation.
// 
// This program is distributed in the hope that it be useful but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License along with
// Rfeed.  If not, see <https://www.gnu.org/licenses/>.

#ifndef CMD_H
#define CMD_H

#include "feed.h"

enum CMD_RES {
	CMD_RES_SUCCESS = 0,
	CMD_RES_ERR,
	CMD_RES_QUIT
};

typedef void (*cmd_func)(size_t i, struct feed_entry **ep, size_t en);

struct cmd {
	const char *name;
	cmd_func func;
};

extern const struct cmd cmds[];
extern const size_t cmdn;

int cmd(const char *str, struct feed_entry **ep, size_t en);

#endif
