// Copyright (C) 2022-2024 B.R.S. Roso.
// 
// Rfeed is free software: you can redistribute it and/or modify it under the
// terms of the GNU General Public License version 3 as published by the Free
// Software Foundation.
// 
// This program is distributed in the hope that it be useful but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License along with
// Rfeed.  If not, see <https://www.gnu.org/licenses/>.

#include <string.h>
#include <stdlib.h>
#include "conf.h"

char *conf_status_file;
char *conf_viewer;
char *conf_summary_filter;

static void conf_string_set(char **conf, const char *str)
{
	free(*conf);
	*conf = strdup(str);
	if (!*conf)
		abort();
}

void conf_status_file_set(const char *file)
{
	conf_string_set(&conf_status_file, file);
}

void conf_viewer_set(const char *prog)
{
	conf_string_set(&conf_viewer, prog);
}

void conf_summary_filter_set(const char *prog)
{
	conf_string_set(&conf_summary_filter, prog);
}
