// Copyright (C) 2022-2024 B.R.S. Roso.
// 
// Rfeed is free software: you can redistribute it and/or modify it under the
// terms of the GNU General Public License version 3 as published by the Free
// Software Foundation.
// 
// This program is distributed in the hope that it be useful but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License along with
// Rfeed.  If not, see <https://www.gnu.org/licenses/>.

#include <stdio.h>
#include <stdlib.h>
#include "../hashtab.h"

void test(const char *str, uint64_t val)
{
	uint64_t h = hash64(str);
	printf("\"%s\" = %jx ", str, (uintmax_t)h);
	if (val == h)
		printf(" (OK!)\n");
	else {
		printf(" (BAD!)\n");
		exit(1);
	}
}

int main()
{
	test("", 0xcbf29ce484222325);
	test("a", 0xaf63dc4c8601ec8c);
	test("foobar", 0x85944171f73967e8);

	return 0;
}
