// Copyright (C) 2022-2024 B.R.S. Roso.
// 
// Rfeed is free software: you can redistribute it and/or modify it under the
// terms of the GNU General Public License version 3 as published by the Free
// Software Foundation.
// 
// This program is distributed in the hope that it be useful but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
// A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License along with
// Rfeed.  If not, see <https://www.gnu.org/licenses/>.

#include <stdlib.h>
#include <stdarg.h>
#include <stdio.h>

char *vsprintf2(const char *fmt, va_list ap)
{
	va_list aq;
	va_copy(aq, ap);
	const int n1 = vsnprintf(NULL, 0, fmt, aq) + 1;
	va_end(aq);
	if (n1 < 0)
		return NULL;
	char *str = malloc(n1);
	if (str == NULL)
		return NULL;
	const int n2 = vsnprintf(str, n1, fmt, ap);
	if (n1 != n2 + 1) {
		free(str);
		return NULL;
	}

	return str;
}

char *sprintf2(const char *fmt, ...)
{
	va_list ap;
	va_start(ap, fmt);
	char *res = vsprintf2(fmt, ap);
	va_end(ap);

	return res;
}
